#!/usr/bin/env ruby

require 'rbconfig'
require 'fileutils'
require 'icon-artist'

include Config
include IconArtist

sharedir = "#{ENV['DESTDIR']}/#{ARTIST_SHAREDIR}"
bindir = "#{ENV['DESTDIR']}/#{CONFIG['bindir']}"
nautilus_ext_dir = "#{ENV['DESTDIR']}/usr/lib/nautilus/extensions-2.0/python"

# Create necessary folder structure
FileUtils::mkdir_p("#{sharedir}/templates")
FileUtils::mkdir_p("#{bindir}")
FileUtils::mkdir_p(nautilus_ext_dir)

# Install templates
FileUtils::install('./data/templates/echo-default.svg', "#{sharedir}/templates/echo-default.svg")
FileUtils::install('./data/templates/echo-paper.svg', "#{sharedir}/templates/echo-paper.svg")
FileUtils::install('./data/templates/echo-emotes.svg', "#{sharedir}/templates/echo-emotes.svg")
FileUtils::install('./data/templates/echo-perspective-action-new.svg', "#{sharedir}/templates/echo-perspective-action-new.svg")
FileUtils::install('./data/templates/echo-perspective-folder.svg', "#{sharedir}/templates/echo-perspective-folder.svg")
FileUtils::install('./data/templates/echo-perspective-folder-open.svg', "#{sharedir}/templates/echo-perspective-folder-open.svg")

# Install scripts
FileUtils::install('./apps/echo-git-setup', "#{bindir}/echo-git-setup")
FileUtils::install('./apps/echo-git-update', "#{bindir}/echo-git-update")
FileUtils::install('./apps/echo-icon-add', "#{bindir}/echo-icon-add")
FileUtils::install('./apps/echo-icon-new', "#{bindir}/echo-icon-new")
FileUtils::install('./apps/echo-icon-check', "#{bindir}/echo-icon-check")
FileUtils::install('./apps/echo-icon-render', "#{bindir}/echo-icon-render")
FileUtils::install('./apps/echo-icon-new-gtk', "#{bindir}/echo-icon-new-gtk")

# Install nautilus extensions (in python)
FileUtils::install('./nautilus/echo-new-icon.py', "#{nautilus_ext_dir}/echo-new-icon.py")

