import gtk

class ActionPane(gtk.VBox):
    def __init__(self, theme_processor, icon_view_left, icon_view_right):
        gtk.VBox.__init__(self)
        
	self.theme_processor = theme_processor
	self.icon_view_left = icon_view_left
	self.icon_view_right = icon_view_right

        self.toolbar = gtk.Toolbar()
	self.pack_start(self.toolbar)

        self.link_button = gtk.ToolButton(label='Link')
	self.link_button.set_icon_name('stock_link')

        self.link_button.connect('clicked', self.do_link)

	self.toolbar.insert(self.link_button, -1)

	self.save_button = gtk.ToolButton(label='Save')
        self.save_button.set_icon_name('stock_save')

        self.save_button.connect('clicked', self.do_save)

        self.toolbar.insert(self.save_button, -1)

    def do_save(self, action_widget):
        context_map = self.theme_processor.generate_context_map()
        self.theme_processor.output_link_file(context_map)

    def do_link(self, action_widget):
        target_paths = self.icon_view_left.get_selected_items()
	if len(target_paths) > 0:
	    target_path = target_paths[0]
	else:
	    return
        
        source_paths = self.icon_view_right.get_selected_items()
	if len(source_paths) > 0:
	    source_path = source_paths[0]
	else:
	    return

        target_model = self.icon_view_left.get_model()
	target_path = target_model.convert_path_to_child_path(target_path)
        source_model = self.icon_view_right.get_model()
        source_path = source_model.convert_path_to_child_path(source_path)

        self.theme_processor.link(target_path, source_path)

