import gtk
import gobject

class DetailsPane(gtk.Expander):
    def __init__(self, theme_processor):
        gtk.Expander.__init__(self)
	self.set_label('Details')
        self.set_expanded(True)

	self.main_vbox = gtk.VBox(spacing=5)
	self.icon_vbox = gtk.VBox()
	self.main_vbox.pack_start(self.icon_vbox)
	self.add(self.main_vbox)

        counter_vbox = gtk.VBox()
	counter_vbox.pack_start(gtk.HSeparator())
	count_hbox = gtk.HBox(spacing=5)
	count_hbox.pack_start(gtk.Label('Icon Count:'), False, False)
	self.count_label = gtk.Label()
        count_hbox.pack_start(self.count_label, False, False)
	counter_vbox.pack_start(count_hbox)

	self.main_vbox.pack_end(counter_vbox, False, False)

	self.theme_processor = theme_processor

    def foreach_icon(self, icon_view, path, data):
        source_model =  icon_view.get_model()
        source_iter = source_model.get_iter(path)
	
	pb = []
        pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_12), 12))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_16), 16))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_22), 22))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_24), 24))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_32), 32))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_36), 36))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_48), 48))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_64), 64))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_96), 96))
	pb.append((source_model.get_value(source_iter, self.theme_processor.COL_SIZE_128), 128))

        hbox = gtk.HBox(spacing=5)
        for p in pb:
	    
	    if p[0]:
	        i = gtk.Image()
		i.set_from_pixbuf(p[0])

		vbox = gtk.VBox()
                label = gtk.Label()
		label.set_markup('<b>%ix%i</b>'%(p[1], p[1]))
		vbox.pack_start(label)
		vbox.pack_start(i, False, False)
		hbox.pack_start(vbox, False, False)

        self.icon_vbox.pack_end(hbox)

        hbox = gtk.HBox(spacing=5)
	label = gtk.Label()
	label.set_markup('<b>Name:</b>')
	hbox.pack_start(label, False, False)

        label = gtk.Label(source_model.get_value(source_iter, self.theme_processor.COL_NAME))
	hbox.pack_start(label, False, False)

	self.icon_vbox.pack_start(hbox)

        hbox = gtk.HBox(spacing=5)
	label = gtk.Label()
	label.set_markup('<b>Theme:</b>')
	hbox.pack_start(label, False, False)

	label = gtk.Label(source_model.get_value(source_iter, self.theme_processor.COL_THEME))
	hbox.pack_start(label, False, False)
	
	self.icon_vbox.pack_start(hbox)

        hbox = gtk.HBox(spacing=5)
	label = gtk.Label()
	label.set_markup('<b>Context:</b>')
	hbox.pack_start(label, False, False)
	
        label = gtk.Label(source_model.get_value(source_iter, self.theme_processor.COL_CONTEXT))
	hbox.pack_start(label, False, False)

	self.icon_vbox.pack_start(hbox)

    def selection_changed(self, icon_view):
        self.main_vbox.remove(self.icon_vbox)
        self.icon_vbox = gtk.VBox()
	self.main_vbox.add(self.icon_vbox)
        icon_view.selected_foreach(self.foreach_icon)
	self.main_vbox.show_all()
