import gtk

class FilterPane(gtk.Expander):
    def __init__(self, theme_processor, filter_view):
        gtk.Expander.__init__(self)
	
	self.theme_processor = theme_processor
	self.filter_model = theme_processor.icon_model.filter_new()
	self.filter_view = filter_view
	self.filter_view.set_model(self.filter_model)

        self.filter_model.set_visible_func(self.filter)

        self.set_label('Filters')
        self.set_expanded(True)

	self.populate()

    def set_active_theme(self, active):
        self.theme_filter.set_active(active)

    def filter_theme (self, model, iter):
        action = self.theme_filter.get_active_text()

        is_current_theme = model.get(iter, self.theme_processor.COL_THEME)[0] == self.theme_processor.icon_theme_name
       
	if action == self.theme_processor.icon_theme_name:
	    return is_current_theme
	elif action == "Other":
	    return not is_current_theme

        return True

    def filter_is_link(self, model, iter):
        show_links = self.is_link_checkbox.get_active()

        is_link = model.get(iter, self.theme_processor.COL_IS_LINK)[0]
	if not show_links:
	    return not is_link

        return True

    def filter_context(self, model, iter):
        context = self.context_filter.get_active_text()

        is_current_context = model.get(iter, self.theme_processor.COL_CONTEXT)[0] == context 
       
        if context == 'All':
	    return True
	else:
	    return is_current_context


    def filter(self, model, iter):
        result = self.filter_theme(model, iter)
        result = result and self.filter_is_link(model, iter)
	result = result and self.filter_context(model, iter)

	return result

    def filter_changed(self, obj):
        self.filter_model.refilter()

    def populate_theme_filter(self):
        hbox = gtk.HBox()
        hbox.pack_start(gtk.Label("Theme Filter"), False, False, 5)
        self.theme_filter = gtk.combo_box_new_text()
        hbox.pack_start(self.theme_filter)
	self.main_vbox.pack_start(hbox)

        self.theme_filter.append_text("All")
        self.theme_filter.append_text(self.theme_processor.icon_theme_name)
	self.theme_filter.append_text("Other")
 
        self.theme_filter.connect('changed', self.filter_changed)

    def populate_show_links_filter(self):
        hbox = gtk.HBox()
        self.is_link_checkbox = gtk.CheckButton('Display Links')
        hbox.pack_start(self.is_link_checkbox)
        self.main_vbox.pack_start(hbox)

        self.is_link_checkbox.connect ('toggled', self.filter_changed)

    def context_added(self, theme_processor, context):
        self.context_filter.append_text(context)

    def sort_context(self, model, iter1, iter2):
        a = model.get_value(iter1, 0)
	b = model.get_value(iter2, 0)

	if a == 'All':
	    return -1
	elif b == 'All':
	    return 1
	elif a < b:
	    return -1
	elif b < a:
	    return 1
	else:
	    return 0
	   
    def populate_context_filter(self):
        hbox = gtk.HBox()
        hbox.pack_start(gtk.Label("Context Filter"), False, False, 5)
        self.context_filter = gtk.combo_box_new_text()
	model = self.context_filter.get_model()
	model.set_sort_func(0, self.sort_context)
        model.set_sort_column_id(0, gtk.SORT_ASCENDING)
        hbox.pack_start(self.context_filter)
	self.main_vbox.pack_start(hbox)

        self.context_filter.append_text("All")

	for context in self.theme_processor.context_list:
            self.context_filter.append_text(context)
        
	self.theme_processor.connect('context-added', self.context_added)
	self.context_filter.set_active(0)
        self.context_filter.connect('changed', self.filter_changed)

    def populate (self):
        self.main_vbox = gtk.VBox()
	self.add(self.main_vbox)
	self.populate_theme_filter()
	self.populate_context_filter()
	self.populate_show_links_filter()



    
