#!/usr/bin/env ruby

require 'rbconfig'
require 'fileutils'

include Config

$sitelibdir = CONFIG["sitelibdir"]
$datadir = CONFIG["datadir"]
sitelibdir = "#{ENV['DESTDIR']}/#{$sitelibdir}"
datadir = "#{ENV['DESTDIR']}/#{$datadir}"

# First have the theme-settings.rb use the correct datadir path
op = File.open('./lib/icon-artist/theme-settings.rb', 'w')
IO.readlines('./lib/icon-artist/theme-settings.rb.in').each do |ip|
  ip.gsub!('@sharedir@', "\"#{$datadir}/icon-artist\"")
  op.puts ip
end
op.close

# Create necessary folder structure
FileUtils::mkdir_p("#{sitelibdir}/icon-artist")
FileUtils::mkdir_p("#{datadir}/icon-artist/buildsys")
FileUtils::mkdir_p("#{datadir}/icon-artist/templates")
FileUtils::mkdir_p("#{datadir}/icon-artist/theme")

# Install libraries
FileUtils::install('./lib/icon-artist/theme-settings.rb', "#{sitelibdir}/icon-artist/theme-settings.rb")
FileUtils::install('./lib/icon-artist/icon.rb', "#{sitelibdir}/icon-artist/icon.rb")
FileUtils::install('./lib/icon-artist/icontheme.rb', "#{sitelibdir}/icon-artist/icontheme.rb")
FileUtils::install('./lib/icon-artist/buildsystem.rb', "#{sitelibdir}/icon-artist/buildsystem.rb")
FileUtils::install('./lib/icon-artist/gitrepo.rb', "#{sitelibdir}/icon-artist/gitrepo.rb")
FileUtils::install('./lib/icon-artist.rb', "#{sitelibdir}/icon-artist.rb")

# Install data
FileUtils::install('./data/templates/default.svg', "#{datadir}/icon-artist/templates/default.svg")
FileUtils::install('./data/theme/index.theme.in', "#{datadir}/icon-artist/theme/index.theme.in")
FileUtils::install('./data/theme/index.theme.in.in', "#{datadir}/icon-artist/theme/index.theme.in.in")
FileUtils::install('./data/buildsys/configure.src.in', "#{datadir}/icon-artist/buildsys/configure.src.in")
FileUtils::install('./data/buildsys/legacy-icon-mapping.dtd', "#{datadir}/icon-artist/buildsys/legacy-icon-mapping.dtd")
FileUtils::install('./data/buildsys/legacy-icon-mapping.xml', "#{datadir}/icon-artist/buildsys/legacy-icon-mapping.xml")
FileUtils::install('./data/buildsys/Makefile.context.in', "#{datadir}/icon-artist/buildsys/Makefile.context.in")
FileUtils::install('./data/buildsys/Makefile.src.in', "#{datadir}/icon-artist/buildsys/Makefile.src.in")
FileUtils::install('./data/buildsys/Makefile.theme.src.in', "#{datadir}/icon-artist/buildsys/Makefile.theme.src.in")
FileUtils::install('./data/buildsys/theme-create.rb.in', "#{datadir}/icon-artist/buildsys/theme-create.rb.in")

